22f6f974ed8481d17811f244845fd6daf7f2a56d
[asterisk/asterisk.git] / contrib / init.d / rc.debian.asterisk
1 #! /bin/sh
2 # $Id$
3 #
4 # Mon Jun 04 2007 IƱaki Baz Castillo <ibc@in.ilimit.es>
5 # - Eliminated SAFE_ASTERISK since it doesn't work as LSB script (it could require a independent "safe_asterisk" init script).
6 # - Load and use the standar "/lib/lsb/init-functions".
7 # - Added "--oknodo" to "start-stop-daemon" for compatibility with LSB:
8 #   http://www.linux-foundation.org/spec/refspecs/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/iniscrptact.html
9 #
10 # Thu Nov 17 2005 Gregory Boehnlein <damin@nacs.net>
11 # - Reversed behavior of LD_ASSUME_KERNEL=2.4.1
12 # - Added detailed failure messages
13 #
14 # Sun Jul 18 2004 Gregory Boehnlein <damin@nacs.net>
15 # - Added test for safe_asterisk
16 # - Changed "stop gracefully" to "stop now"
17 # - Added support for -U and -G command line options
18 # - Modified "reload" to call asterisk -rx 'reload' 
19
20 PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
21 NAME=asterisk
22 DESC="Asterisk PBX"
23 # Full path to asterisk binary
24 DAEMON=__ASTERISK_SBIN_DIR__/asterisk
25 ASTVARRUNDIR=__ASTERISK_VARRUN_DIR__
26 ASTETCDIR=__ASTERISK_ETC_DIR__
27 TRUE=/bin/true
28
29 ### BEGIN INIT INFO
30 # Provides:             asterisk
31 # Required-Start:       $local_fs
32 # Required-Stop:        $local_fs
33 # Should-Start:         dahdi mysql postgresql
34 # Should-Stop:
35 # Default-Start:        2 3 4 5
36 # Default-Stop:         0 1 6
37 # Short-Description:    Asterisk PBX
38 # Description:          the Asterisk Open Source PBX
39 ### END INIT INFO
40
41 set -e
42
43 if ! [ -x $DAEMON ] ; then
44         echo "ERROR: $DAEMON not found"
45         exit 0
46 fi
47
48 if ! [ -d $ASTETCDIR ] ; then
49         echo "ERROR: $ASTETCDIR directory not found"
50         exit 0
51 fi
52
53 # Use the LSB standar functions for services management
54 . /lib/lsb/init-functions
55
56 # Allow configuration overrides in /etc/default/asterisk
57 CONFIG0=`readlink $0`
58 if [ "$CONFIG0" = "" ]; then
59         CONFIGFILE=/etc/default/`basename $0`
60 else
61         CONFIGFILE=/etc/default/`basename $CONFIG0`
62 fi
63 [ -r $CONFIGFILE ] && . $CONFIGFILE
64
65 case "$1" in
66   start)
67         # Check if Asterisk is already running.  If it is, then bug out, because
68         # starting up Asterisk when Asterisk is already running is very bad.
69         VERSION=`${DAEMON} -rx 'core show version' || ${TRUE}`
70         if [ "`echo $VERSION | cut -c 1-8`" = "Asterisk" ]; then
71                 echo "Asterisk is already running.  $0 will exit now."
72                 exit 1
73         fi
74
75         log_begin_msg "Starting $DESC: $NAME"
76         if [ ! -d $ASTVARRUNDIR ]; then
77                 mkdir -p $ASTVARRUNDIR
78         fi
79
80         if [ $AST_USER ] ; then
81                 ASTARGS="-U $AST_USER"
82                 chown $AST_USER $ASTVARRUNDIR
83         fi
84         if [ $AST_GROUP ] ; then
85                 ASTARGS="$ASTARGS -G $AST_GROUP"
86                 chgrp $AST_GROUP $ASTVARRUNDIR
87         fi
88         if [ $ALTCONF ]; then
89                 ASTARGS="$ASTARGS -C \"$ALTCONF\""
90         fi
91         if [ "x$COREDUMP" = "xyes" ]; then
92                 ASTARGS="$ASTARGS -g"
93         fi
94         if [ "0$MAXLOAD" -gt "0" ]; then
95                 ASTARGS="$ASTARGS -L $MAXLOAD"
96         fi
97         if [ "0$MAXCALLS" -gt "0" ]; then
98                 ASTARGS="$ASTARGS -M $MAXCALLS"
99         fi
100         if [ "0$VERBOSITY" -gt "0" ]; then
101                 for i in `seq 1 $VERBOSITY`; do
102                         ASTARGS="$ASTARGS -v"
103                 done
104         fi
105         if [ "x$INTERNALTIMING" = "xyes" ]; then
106                 ASTARGS="$ASTARGS -I"
107         fi
108         if [ "x$TEMPRECORDINGLOCATION" = "xyes" -o "x$TMPRECORDINGLOCATION" = "xyes" ]; then
109                 ASTARGS="$ASTARGS -t"
110         fi
111         # "start-stop-daemon --oknodo" returns 0 even if Asterisk was already running (as LSB expects):
112         if test "x$COLOR" = "xyes" ; then
113                 export TERM=linux
114                 start-stop-daemon --start --oknodo --background --exec $DAEMON -- $ASTARGS -c
115         else
116                 start-stop-daemon --start --oknodo --exec $DAEMON -- $ASTARGS
117         fi
118         log_end_msg $?
119         ;;
120   stop)
121         log_begin_msg "Stopping $DESC: $NAME"
122         # "start-stop-daemon --oknodo" returns 0 even if Asterisk was already stopped (as LSB expects):
123         start-stop-daemon --stop --oknodo --exec $DAEMON
124         log_end_msg $?
125         ;;
126   reload)
127         echo "Reloading $DESC configuration files."
128         $DAEMON -rx 'module reload' > /dev/null 2> /dev/null
129         ;;
130   restart|force-reload)
131         $0 stop
132         sleep 2  # It needs some time to really be stopped.
133         $0 start
134         # "restart|force-reload" starts Asterisk and returns 0 even if Asterisk was stopped (as LSB expects).
135         ;;
136   *)
137         N=/etc/init.d/$NAME
138         echo "Usage: $N {start|stop|restart|reload|force-reload}" >&2
139         exit 1
140         ;;
141 esac